/**
 * Below is a sample adapter for connecting with a webservice.
 */

var myRemoteAdapter={
    server:"http://localhost:9090/jqmws/",
    save:function(obj,callback,foo){
        $.get(this.server+"todo.php?axt=save&data="+encodeURIComponent(JSON.stringify(obj)),
            function(id){
                obj.id=id;
                $(document).trigger(obj.name + ":save", obj);
                if(callback)
                    callback(obj);
            }
        );
    },
    fetch:function(id,callback){
        $.get(this.server+"todo.php?axt=get&data="+encodeURIComponent(id),
            function(obj){
                
                obj=JSON.parse(obj);
                if(callback)
                    callback(obj);
            }
        );
    },
    fetchAll:function(id,callback){
        $.get(this.server+"todo.php?axt=getAll",
            function(obj){
                obj=JSON.parse(obj);
                if(callback)
                    callback(obj);
            }
        );
    },
    remove:function(obj,callback){
        $.get(this.server+"todo.php?axt=delete&data="+encodeURIComponent(obj.id),
            function(obj){
                $(document).trigger(obj.name + ":remove", obj.id);
                obj=JSON.parse(obj);
                if(callback)
                    callback(obj);
            }
        );
    }
}


Todo =  $.mvc.model.extend("todo",{
    validate:function(opts){
        if(opts&&opts.trigger)
            return "error validating";
        return true;
    },
    text: '',
    isComplete:false,
    isArchived:false,
    archiveItem:function(){
        debugger;
        this.isArchived=true;
        this.isComplete=false;
        this.save();
        return this;
    },
    finishItem:function(){
        this.isArchived=false;
        this.isComplete=true;
        this.save();
        return this;
    },
    resetItem:function(){
        this.isArchived=false;
        this.isComplete=false;
        this.save();
        return this;
    }
});

var todo = new Todo();